//==========================================================================
//
//      io/serial/mips/bcm53xx/bcm53xx_serial.h
//
//      Broadcom 53xx Serial I/O definitions.
//
//==========================================================================
//####ECOSGPLCOPYRIGHTBEGIN####
// -------------------------------------------
// This file is part of eCos, the Embedded Configurable Operating System.
// Copyright (C) 1998, 1999, 2000, 2001, 2002 Red Hat, Inc.
//
// eCos is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 or (at your option) any later version.
//
// eCos is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
//
// You should have received a copy of the GNU General Public License along
// with eCos; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
//
// As a special exception, if other files instantiate templates or use macros
// or inline functions from this file, or you compile this file and link it
// with other works to produce a work based on this file, this file does not
// by itself cause the resulting work to be covered by the GNU General Public
// License. However the source code for this file must still be made available
// in accordance with section (3) of the GNU General Public License.
//
// This exception does not invalidate any other reasons why a work based on
// this file might be covered by the GNU General Public License.
//
// Alternative licenses for eCos may be arranged by contacting Red Hat, Inc.
// at http://sources.redhat.com/ecos/ecos-license/
// -------------------------------------------
//####ECOSGPLCOPYRIGHTEND####
//==========================================================================
//#####DESCRIPTIONBEGIN####
//
// Author(s):    msieweke, based on MIPS IDT 16550 driver by tmichals, based on driver by dmoseley, based on POWERPC driver by jskov
// Contributors: gthomas, jskov, dmoseley, tmichals
// Date:         2003-07-02
// Purpose:      Broadcom 53xx reference platform serial device driver definitions.
// Description:  Broadcom 53xx serial device driver definitions.
//####DESCRIPTIONEND####
//==========================================================================

// The UART registers are defined here.
#include <cyg/hal/bcm53xx_regs.h>

// Description of serial ports on Broadcom 53xx board

static unsigned int select_baud[] = {
    0,    // Unused
    50,
    75,
    110,
    134,
    150,
    200,
    300,
    600,
    1200,
    1800,
    2400,
    3600,
    4800,
    7200,
    9600,
    14400,
    19200,
    38400,
    57600,
    115200,
    230400
};

static unsigned char select_word_length[] = {
    0, // 0
    0, // 1
    0, // 2
    0, // 3
    0, // 4
    LCR_5BIT,
    LCR_6BIT,
    LCR_7BIT,
    LCR_8BIT
};

static unsigned char select_stop_bits[] = {
    0,       // 0.5 stop bits (set to 1)
    0,       // 1   stop bits
    LCR_STB, // 1.5 stop bits (set to 2)
    LCR_STB  // 2   stop bits
};

static unsigned char select_parity[] = {
    0,                          // No parity
    LCR_PEN | LCR_EPS,          // Even parity
    LCR_PEN,                    // Odd parity
    LCR_PEN | LCR_SP,           // Mark parity
    LCR_PEN | LCR_SP | LCR_EPS, // Space parity
};


// For the 5365, the UART clock should be 1.851 MHz (100 MHz / 54),
// which makes the baudword for 115.2kps = 1.  And we only use 115.2kbps
#define BAUD_115200 1

// EOF bcm53xx_serial.h
